unit Unit1;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Math2D, Ship, EntityManager, LCLType, LCLIntf, ComCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    AutoFire: TCheckBox;
    Image1: TImage;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  S: TShip;
  A: TAsteroid;
  EM: TEntityManager;
  kUP, kDOWN, kLEFT, kRIGHT, kFIRE: boolean;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  FreeAndNil(S);
  FreeAndNil(A);
  FreeAndNil(EM);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Arr, Arr2: array of TLine2D;
begin

  SetLength(Arr, 4);
  Arr[0] := Line2D(120, 0, -40, 60);
  Arr[1] := Line2D(-20, 60, -10, 0);
  Arr[2] := Line2D(-10, 0, -40, -60);
  Arr[3] := Line2D(-40, -60, 120, 0);

  S := TShip.Create(PointF(Image1.Width / 2, Image1.Height / 2 +50), 270 -35,
    0.2, nil, 100, 0);
  S.Dimensions := Arr;


  SetLength(Arr2, 5);

  Arr2[0] := Line2D(0, -2, 3, -1);
  Arr2[1] := Line2D(3, -1, -5, 5);
  Arr2[2] := Line2D(-5, 5, -15, 0);
  Arr2[3] := Line2D(-15, 0, -10, -15);
  Arr2[4] := Line2D(-10, -15, 0, -2);

  A := TAsteroid.Create(PointF(200, 200), 45, 5, nil);
  A.Angle := 150;
  A.Dimensions := Arr2;
  EM := TEntityManager.Create;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  I, J: integer;
  EP, Inter: TPointF;
begin
  if S <> nil then
  begin
    //DRAWING
    Image1.Canvas.Brush.Color := clWhite;
    Image1.Canvas.Clear;

    Image1.Canvas.Pixels[round(S.Pos.X), round(S.Pos.Y)] := clBlack;
    Image1.Canvas.MoveTo(round(S.Polygon[0].x1), round(S.Polygon[0].y1));
    for I := Low(S.Polygon) to High(S.Polygon) do
      Image1.Canvas.LineTo(round(S.Polygon[I].x2), round(S.Polygon[I].y2));

    Image1.Canvas.Pixels[round(A.Pos.X), round(A.Pos.Y)] := clBlack;
    Image1.Canvas.MoveTo(round(A.Polygon[0].x1), round(A.Polygon[0].y1));
    for I := Low(A.Polygon) to High(A.Polygon) do
    begin
      Image1.Canvas.LineTo(round(A.Polygon[I].x1), round(A.Polygon[I].y1));
      Image1.Canvas.LineTo(round(A.Polygon[I].x2), round(A.Polygon[I].y2));
    end;
    //DRAWING
    for I := Low(A.Polygon) to High(A.Polygon) do
    begin
      Image1.Canvas.Ellipse(round(A.Polygon[I].x1 - 3),
        round(A.Polygon[I].y1 - 3), round(A.Polygon[I].x1 + 3),
        round(A.Polygon[I].y1 + 3));
      Image1.Canvas.Ellipse(round(A.Polygon[I].x2 - 3),
        round(A.Polygon[I].y2 - 3), round(A.Polygon[I].x2 + 3),
        round(A.Polygon[I].y2 + 3));
    end;

    //ROTATING ASTEROID
//    A.Angle := A.Angle + 0.5;
    if GetKeyState(VK_R) < 0 then
      A.Angle := A.Angle - 0.5;
    if GetKeyState(VK_F) < 0 then
      A.Angle := A.Angle + 0.5;

    //MOVEMENT
    kUP    := GetKeyState(VK_W) < 0;
    kDOWN  := GetKeyState(VK_S) < 0;
    kLEFT  := GetKeyState(VK_A) < 0;
    kRIGHT := GetKeyState(VK_D) < 0;
    kFIRE  := GetKeyState(VK_SPACE) < 0;

    if AutoFire.Checked then
      kFIRE  := True;

    if kLEFT then
      S.Angle := S.Angle - 1;

    if kRIGHT then
      S.Angle := S.Angle + 1;

    if kUP then
      S.Pos := PointOfAngle(S.Pos.X, S.Pos.Y, 3, S.Angle);

    if kDOWN then
      S.Pos := PointOfAngle(S.Pos.X, S.Pos.Y, 3, S.Angle - 180);

    //FIRING BULLETS
    if kFIRE and (EM <> nil) then
    begin
      EM.Add(S.Pos, PointOfAngle(S.Pos.X, S.Pos.Y, 500, S.Angle + 0.0000000001),
        S.Angle + 0.0000000001, 500, TrackBar1.Position);

    end;

    //DRAWING
    if (EM <> nil) and (EM.Entities.Count > 0) then
    begin
      EM.Update;
      for I := 0 to EM.Entities.Count - 1 do
      begin
        Image1.Canvas.Pen.Color := clRed;
        Image1.Canvas.Ellipse(round(EM.Entities[I].Pos.X - 1),
          round(EM.Entities[I].Pos.Y - 1), round(EM.Entities[I].Pos.X + 1),
          round(EM.Entities[I].Pos.Y + 1));
        Image1.Canvas.MoveTo(round(EM.Entities[I].Pos.X),
          round(EM.Entities[I].Pos.Y));
        EP := PointOfAngle(EM.Entities[I].Pos.X, EM.Entities[I].Pos.Y,
          7, EM.Entities[I].Angle);
        Image1.Canvas.LineTo(round(EP.X), round(EP.Y));
        Image1.Canvas.Pen.Color := clBlack;
      end;
    end;

    //COLLISION DETECTION
    for I := 0 to EM.Entities.Count - 1 do
      for J := Low(A.Polygon) to High(A.Polygon) do
        if LinesIntersect(A.Polygon[J].x1, A.Polygon[J].y1, A.Polygon[J].x2,
          A.Polygon[J].y2, EM.Entities[I].Pos.X, EM.Entities[I].Pos.Y,
          EM.Entities[I].Pos.X + EM.Entities[I].xSpeed, EM.Entities[I].Pos.Y +
          EM.Entities[I].ySpeed, Inter) then
        begin
          EM.Entities[I].Pos := Inter;
          EM.Entities[I].Target := Inter;
        end;
  end;
end;

end.
